﻿----------------------------------------------------------------------------------------------------
-- DroodFocus 4.2.2 - Dot timer
-- Meranannon - Discordia - Vol'jin (EU)
-- rev 1
----------------------------------------------------------------------------------------------------

local DF = DF_namespace

local nbSpells = 0
local dots={}
local frames={}
local nbLines=10

function DF:init_dottimer_frame()

--	for i = 1,nbLines do
--
--		if not frames[i] then
--			frames[i]={}
--			
--			frames[i].targetId=0
--			
--			frames[i].base=CreateFrame("FRAME","DF_DOT_BASE_"..i,DF.anchor[8].frame)
--			frames[i].text=frames[i].base:CreateFontString("DF_DOT_TEXT_"..i,"ARTWORK")
--			
--			frames[i].icons={}
--			for ic = 1,6 do
--				frames[i].icons[ic]={}
--				
--				frames[i].icons[ic].spellid=0
--				frames[i].icons[ic]=CreateFrame("FRAME","DF_DOT_"..tostring(i).."ICON_"..tostring(ic),frames[i].base)
--				frames[i].icons[ic].texture = frames[i].icons[ic]:CreateTexture(nil,"BACKGROUND")
--
--				frames[i].icons[ic].cooldownframe=CreateFrame("Cooldown","DF_DOTS_"..tostring(i).."COOLDOWN_"..tostring(ic),frames[i].icons[ic])
--				frames[i].icons[ic].cooldownframe:SetAllPoints(frames[i].icons[ic])
--				frames[i].icons[ic].cooldownframe.noCooldownCount=true
--				frames[i].icons[ic].cooldownframe:SetReverse(true)
--				frames[i].icons[ic].cooldownframe:SetDrawEdge(true)
--				
--			end
--			
--		end
--
--
--
--		frames[i].base:SetMovable(false)
--		frames[i].base:EnableMouse(false)		
--		frames[i].base:SetWidth(128)
--		frames[i].base:SetHeight(22)
--		frames[i].base:SetPoint("TOPLEFT", DF.anchor[8].frame, "TOPLEFT", 8, -8+(-23*(i-1)))
--		frames[i].base:SetFrameLevel(1)
--		t=frames[i].base:CreateTexture(nil)
--		frames[i].base.texture=t
--		frames[i].base.texture:SetAllPoints(frames[i].base)
--		frames[i].base.texture:SetTexture(0,0,0,0)
--
--		DF:MySetFont(frames[i].text,"Interface\\AddOns\\DroodFocus\\datas\\font.ttf",9,"OUTLINE")
--		frames[i].text:SetShadowColor(0, 0, 0, 0.75)
--		frames[i].text:SetShadowOffset(0.5, -0.5)
--		frames[i].text:SetWidth(128)
--		frames[i].text:SetHeight(22)			
--		frames[i].text:SetTextColor(1, 1, 1, 1)
--		frames[i].text:SetText("")
--		frames[i].text:SetJustifyH('RIGHT')
--		frames[i].text:SetJustifyV('MIDDLE')
--		frames[i].text:ClearAllPoints()	
--		frames[i].text:SetPoint("RIGHT", frames[i].base,"LEFT", 0, 0)
--
--		for ic = 1,6 do
--			frames[i].icons[ic]:SetMovable(false)
--			frames[i].icons[ic]:EnableMouse(false)		
--			frames[i].icons[ic]:SetWidth(22)
--			frames[i].icons[ic]:SetHeight(22)
--			frames[i].icons[ic]:SetPoint("TOPLEFT", frames[i].base, "TOPLEFT", (ic-1)*23, 0)
--			frames[i].icons[ic]:SetFrameLevel(2)
--
--			frames[i].icons[ic].texture:SetTexCoord(0, 1, 0, 1)
--			frames[i].icons[ic].texture:SetWidth(64)
--			frames[i].icons[ic].texture:SetHeight(64)
--			frames[i].icons[ic].texture:SetBlendMode("BLEND")
--			frames[i].icons[ic].texture:ClearAllPoints()
--			frames[i].icons[ic].texture:SetAllPoints(frames[i].icons[ic])
--			frames[i].icons[ic].texture:SetTexture(0,0,0,0)	
--			
--		end	
--		
--	end
	
end

-- reset de la table
function DF:dottimer_clearDots()
	dots=table.wipe(dots)
	
--	for i = 1,nbLines do
--		if frames[i] then
--			frames[i].targetId=0
--			for ic = 1,6 do
--				frames[i].icons[ic].spellid=0				
--			end
--		end
--	end
	
end

-- ajoute ou met a jour un dot
function DF:dottimer_addDots(pTime,pTarget,pSpell,isNew,stype)

	local nbDots=getn(dots)
	local index = nil
	
	if nbDots>0 then
		
		for il = 1,nbDots do
			
			if dots[il].cible==pTarget and dots[il].spellid==pSpell then
				index=il
				break
			end
			
		end
		
	end
	
	if index then
	
		if isNew==true then
			dots[index].dotInterval=0
			dots[index].nbtic=0
			dots[index].stype=stype
			dots[index].TimeLeft=0
			dots[index].duration=0
			
		else
			dots[index].dotInterval=pTime-dots[index].heure
			dots[index].nbtic=dots[index].nbtic+1
			
		end
		
		dots[index].heure=pTime
		dots[index].cible=pTarget
		dots[index].spellid=pSpell
		
	else
		-- nouvelle entrée
		index=nbDots+1

		dots[index]={}
		dots[index].heure=pTime
		dots[index].cible=pTarget
		dots[index].spellid=pSpell
		dots[index].TimeLeft=0
		dots[index].duration=0		
		dots[index].dotInterval=0
		dots[index].nbtic=0
		dots[index].stype=stype
		
	end
	
end

-- trouve un dot et retourne l'index et l'heure du dernier ticks (ou application)
function DF:dottimer_findDots(pTarget,pSpell)
	local nbDots=getn(dots)
	local index = nil
	
	if nbDots>0 then
		
		for i = 1,nbDots do
			
			if dots[i].cible==pTarget and dots[i].spellid==pSpell then
				return i
			end
			
		end
		
	end
	
	return 0
	
end

function DF:dottimer_setDots(index,timeleft,duration)
	if index then
		if timeleft then
			dots[index].TimeLeft=timeleft
		end
		if duration then
			dots[index].duration=duration
		end
	end
end

function DF:spells_getDotDatas(index)
	if dots[index] then
		return dots[index].dotInterval,dots[index].nbtic
	end
	return 0,0
end

function DF:dottimer_update(elapsed)
	local nbDots=getn(dots)
	local line,row=0
	if nbDots>0 then
		
		for i = 1,nbDots do

			if dots[i].dotInterval then
				dots[i].dotInterval=dots[i].dotInterval-elapsed
				if dots[i].dotInterval<0 then
					dots[i].dotInterval=0
				end
			end
			
			if dots[i].TimeLeft then
				
				dots[i].TimeLeft=dots[i].TimeLeft-elapsed
				
				if dots[i].TimeLeft<0 then
					dots[i].TimeLeft=0
				end
			
--				line=DF:dottimer_findLine(dots[i].cible)
--				frames[line].targetId=dots[i].cible
--				
--				row=DF:dottimer_findRow(line,dots[i].spellid)
--				frames[line].icons[row].spellid=dots[i].spellid
--				
--				frames[line].text:SetText(dots[i].cible)
--				
--				if dots[i].TimeLeft==0 then
--					MonitorLine(line,"line "..tostring(line).." icon "..tostring(row).." off")
--					frames[line].icons[row].texture:SetTexture(0,0,0,0)	
--					frames[line].icons[row].cooldownframe:SetCooldown(0,0)
--				else
--					MonitorLine(line,"line "..tostring(line).." icon "..tostring(row).." on")
--					_, _, abiImg, _, _, _, _, _, _ = GetSpellInfo(dots[i].spellid)
--					frames[line].icons[row].texture:SetTexture(abiImg)	
--					frames[line].icons[row].cooldownframe:SetCooldown(dots[i].heure,dots[i].duration)
--				end
			
			end
				
		end
		
	end	
	
end

function DF:dottimer_findLine(targetid)
	local numero=0
	for i = 1,nbLines do
		if frames[i].targetId==targetid then
			return i
		end
		if frames[i].targetId==0 and numero==0 then
			numero=i
		end
	end
	return numero
end

function DF:dottimer_findRow(line,spellid)
	local numero=0
	for i = 1,6 do
		if frames[line].icons[i].spellid==spellid then
			return i
		end
		if frames[line].icons[i].spellid==0 and numero==0 then
			numero=i
		end		
	end
	
	if numero==0 then
		return 1
	else
		return numero
	end
	
end